@echo OFF
rem  * *******************************************************************
rem  *               CASECRE1.CMD - a Windows Command File               *
rem  *         This program is provided by SimoTime Technologies         *
rem  *           (C) Copyright 1987-2019 All Rights Reserved             *
rem  *             Web Site URL:   http://www.simotime.com               *
rem  *                   e-mail:   helpdesk@simotime.com                 *
rem  * *******************************************************************
rem  *
rem  * Text   - Read a file of text info, do case convert, write output.
rem  * Author - SimoTime Technologies
rem  * Date   - January 24, 1996
rem  *
rem  * The job will read an 80-byte file that contains text string
rem  * information. The job will also write a file containing the results
rem  * of the case conversion requests.
rem  *
rem  * This set of programs will run on a mainframe under MVS or on a
rem  * Personal Computer with Windows and Micro Focus Net Express.
rem  *
rem  *    ************
rem  *    * CaseCrE1 *
rem  *    ********cmd*
rem  *         *
rem  *         *
rem  *    ************
rem  *    *   run    ****
rem  *    *********es*  *
rem  *         *        *
rem  *         *        **************************
rem  *         *                                 *
rem  *         *           ************     ************     ************
rem  *         *           * CASEGET1 ******* CaseCrIO ******* CASEPUT1 *
rem  *         *           *******rseq*     ********cbl*     *******rseq*
rem  *         *                                 *
rem  *         *                            ************
rem  *         *                            * SIMOCASE *
rem  *         *                            ********cbl*
rem  *         *
rem  *    ************
rem  *    *   EOJ    *
rem  *    ************
rem  *
rem  * *******************************************************************
rem  * Step 1 of 3 Delete any previously created files...
rem  *
     set CmdName=CaseCrIO
     call ..\Env1BASE %CmdName%
     if "%SYSLOG%" == "" set syslog=c:\SimoLIBR\LOGS\SimoTime.LOG
rem  *
     call SimoNOTE "*******************************************************%CmdName%"
     call SimoNOTE "Starting CmdName %CmdName%"
:DeleteQSAM
     call SimoNOTE "StepInfo Delete previously created file"
     set CASEGET1=%BaseLib1%\DATA\Asc1\CASERS80.DAT
     set CASEPUT1=%BaseLib1%\DATA\Wrk1\CASEPUT1.DAT
     if exist %CASEPUT1% del %CASEPUT1%
rem  *
rem  * *******************************************************************
rem  * Step 2 of 3, Convert input, create a new output file...
rem  *
:ExecuteCASEifyRoutine
     call SimoNOTE "StepInfo Execute the CASE Conversion Program"
     run CaseCrIO
     if not ERRORLEVEL = 0 set JobStatus=0020
     if not %JobStatus% == 0000 goto :EojNok
     call SimoNOTE "DataTake %CASEGet1%"
     call SimoNOTE "DataMake %CASEPUT1%"
rem  *
rem  * *******************************************************************
rem  * Step 3 of 3, Convert Record Sequential File to ASCII/TEXT file...
rem  *
     call SimoNOTE "StepInfo Convert RSEQ to LSEQ"
     set GETRS080=%CASEPUT1%
     set PUTLS080=%BaseLib1%\DATA\Wrk1\CASETXT2.TXT
     if exist %PUTLS080% del %PUTLS080%
     run CV80ARAL
     if not "%ERRORLEVEL%" == "0" set JobStatus=0030
     if not %JobStatus% == 0000 goto :EojNok
     call SimoNOTE "DataTake %GETRS080%"
     call SimoNOTE "DataMake %PUTLS080%"
rem  *
:EojAok
     call SimoNOTE "Finished JobName %CmdName%, Job Status is %JobStatus%"
     goto :End
:EojNok
     call SimoNOTE "ABENDING JobName %CmdName%, Job Status is %JobStatus%"
:End
     if not "%1" == "nopause" pause
