       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CASECRIO.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  Generation Date: 2008-06-14  Generation Time: 18:21:27:26    *
      *                                                               *
      *                                   Record    Record     Key    *
      *  Function  Name     Organization  Format    Max-Min  Pos-Len  *
      *  INPUT     CASEGET1 SEQUENTIAL    FIXED      00080            *
      *                                                               *
      *  OUTPUT    CASEPUT1 SEQUENTIAL    FIXED      00080            *
      *                                                               *
      *****************************************************************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT CASEGET1-FILE  ASSIGN TO       CASEGET1
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS CASEGET1-STATUS.
           SELECT CASEPUT1-FILE  ASSIGN TO       CASEPUT1
                  ORGANIZATION  IS SEQUENTIAL
                  ACCESS MODE   IS SEQUENTIAL
                  FILE STATUS   IS CASEPUT1-STATUS.

      *****************************************************************
       DATA DIVISION.
       FILE SECTION.
       FD  CASEGET1-FILE
           DATA RECORD    IS CASEGET1-REC
           .
       01  CASEGET1-REC.
           05  CASEGET1-DATA-01 PIC X(00080).

       FD  CASEPUT1-FILE
           DATA RECORD    IS CASEPUT1-REC
           .
       01  CASEPUT1-REC.
           05  CASEPUT1-DATA-01 PIC X(00080).

      *****************************************************************
      * This program was created using the SYSMASK3.TXT file as the   *
      * template for the File I/O. It is intended for use with the    *
      * TransCALL facility that makes a call to a routine that does   *
      * the actual conversion between EBCDIC and ASCII. For more      *
      * information or questions contact SimoTime Technologies.       *
      *                                                               *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      * The SYSMASK3 provides for the sequential reading of the input *
      * file and the sequential writing of the output file.           *
      * If the output file is indexed then the input file must be in  *
      * sequence by the field that will be used to provide the key    *
      * for the output file.                                          *
      *                                                               *
      * If the key field is not in sequence then refer to SYSMASK4    *
      * to provide for a random add or update of the indexed file.    *
      *****************************************************************
       WORKING-STORAGE SECTION.
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CASECRIO '.
           05  T2 pic X(34) value 'Example of Case Conversion & COBOL'.
           05  T3 pic X(10) value ' v08.02.16'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CASECRIO '.
           05  C2 pic X(20) value 'Created by SimoZAPS,'.
           05  C3 pic X(20) value '  a utility package '.
           05  C4 pic X(28) value 'of   SimoTime Technologies  '.

       01  CASEGET1-STATUS.
           05  CASEGET1-STATUS-L     pic X.
           05  CASEGET1-STATUS-R     pic X.
       01  CASEGET1-EOF              pic X       value 'N'.
       01  CASEGET1-OPEN-FLAG        pic X       value 'C'.

       01  CASEPUT1-STATUS.
           05  CASEPUT1-STATUS-L     pic X.
           05  CASEPUT1-STATUS-R     pic X.
       01  CASEPUT1-EOF              pic X       value 'N'.
       01  CASEPUT1-OPEN-FLAG        pic X       value 'C'.

       01  CASEGET1-LRECL    pic 9(5)    value 00080.
       01  CASEPUT1-LRECL    pic 9(5)    value 00080.

      *****************************************************************
      * The following buffers are used to create a four-byte status   *
      * code that may be displayed.                                   *
      *****************************************************************
       01  IO-STATUS.
           05  IO-STAT1            pic X.
           05  IO-STAT2            pic X.
       01  IO-STATUS-04.
           05  IO-STATUS-0401      pic 9     value 0.
           05  IO-STATUS-0403      pic 999   value 0.
       01  TWO-BYTES-BINARY        pic 9(4)  BINARY.
       01  TWO-BYTES-ALPHA         redefines TWO-BYTES-BINARY.
           05  TWO-BYTES-LEFT      pic X.
           05  TWO-BYTES-RIGHT     pic X.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MESSAGE-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER.
           05  MESSAGE-HEADER      pic X(11)   value '* CASECRIO '.
           05  MESSAGE-TEXT.
               10  MESSAGE-TEXT-1  pic X(68)   value SPACES.
               10  MESSAGE-TEXT-2  pic X(188)  value SPACES.

      *****************************************************************
       01  PROGRAM-NAME            pic X(8)     value 'CASECRIO'.

       01  APPL-RESULT             pic S9(9)    comp.
           88  APPL-AOK            value 0.
           88  APPL-EOF            value 16.

       01  CASEGET1-TOTAL.
           05  CASEGET1-RDR  pic 9(9)    value 0.
           05  filler      pic X(3)    value ' - '.
           05  filler      pic X(23)   value 'Line count for CASEGET1'.
       01  CASEPUT1-TOTAL.
           05  CASEPUT1-ADD  pic 9(9)    value 0.
           05  filler      pic X(3)    value ' - '.
           05  filler      pic X(23)   value 'Line count for CASEPUT1'.

       COPY PASSCASE.

      *****************************************************************
       PROCEDURE DIVISION.
           perform Z-POST-COPYRIGHT
           perform CASEGET1-OPEN
           perform CASEPUT1-OPEN

           add 80 to ZERO giving CASE-PASS-STRING-SIZE

           perform until CASEGET1-STATUS not = '00'
               perform CASEGET1-READ
               if  CASEGET1-STATUS = '00'
                   add 1 to CASEGET1-RDR
                   perform BUILD-OUTPUT-RECORD
                   perform CASEPUT1-WRITE
                   if  CASEPUT1-STATUS = '00'
                       add 1 to CASEPUT1-ADD
                   end-if
               end-if
           end-perform

           move CASEGET1-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           move CASEPUT1-TOTAL to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT

           if  APPL-EOF
               move 'is Complete...' to MESSAGE-TEXT
           else
               move 'is ABENDING...' to MESSAGE-TEXT
           end-if
           perform Z-DISPLAY-MESSAGE-TEXT

           perform CASEPUT1-CLOSE
           perform CASEGET1-CLOSE
           GOBACK.

      *****************************************************************
       BUILD-OUTPUT-RECORD.
      *>   TransCALL process...
           move SPACES to CASE-PASS-BUFFER
           move CASEGET1-REC(1:80) to CASE-PASS-BUFFER
           move 'Input Record ..... '   to CASEPUT1-REC
           move CASE-PASS-BUFFER(1:80) to CASEPUT1-REC(20:61)
           perform CASEPUT1-WRITE

           move '0' to CASE-PASS-REQUEST
           call 'SIMOCASE' using CASE-PASS-AREA
           move 'Convert Lower .... '    to CASEPUT1-REC
           move CASE-PASS-BUFFER(1:80) to CASEPUT1-REC(20:61)
           perform CASEPUT1-WRITE

           move '2' to CASE-PASS-REQUEST
           call 'SIMOCASE' using CASE-PASS-AREA
           move 'Capitalization ... '    to CASEPUT1-REC
           move CASE-PASS-BUFFER(1:80) to CASEPUT1-REC(20:61)
           perform CASEPUT1-WRITE

           move '3' to CASE-PASS-REQUEST
           call 'SIMOCASE' using CASE-PASS-AREA
           move 'Edited Words ..... '    to CASEPUT1-REC
           move CASE-PASS-BUFFER(1:80) to CASEPUT1-REC(20:61)
           exit.

      *****************************************************************
      * I/O Routines for the INPUT File...                            *
      *****************************************************************
       CASEGET1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CASEGET1-FILE
           if  CASEGET1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with CASEGET1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CASEGET1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CASEGET1-READ.
           read CASEGET1-FILE
           if  CASEGET1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CASEGET1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if
           if  APPL-AOK
               CONTINUE
           else
               if  APPL-EOF
                   move 'Y' to CASEGET1-EOF
               else
                   move 'READ Failure with CASEGET1' to MESSAGE-TEXT
                   perform Z-DISPLAY-MESSAGE-TEXT
                   move CASEGET1-STATUS to IO-STATUS
                   perform Z-DISPLAY-IO-STATUS
                   perform Z-ABEND-PROGRAM
               end-if
           end-if
           exit.
      *---------------------------------------------------------------*
       CASEGET1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open input CASEGET1-FILE
           if  CASEGET1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to CASEGET1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with CASEGET1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CASEGET1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * I/O Routines for the OUTPUT File...                           *
      *****************************************************************
       CASEPUT1-WRITE.
           if  CASEPUT1-OPEN-FLAG = 'C'
               perform CASEPUT1-OPEN
           end-if
           write CASEPUT1-REC
           if  CASEPUT1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
           else
               if  CASEPUT1-STATUS = '10'
                   add 16 to ZERO giving APPL-RESULT
               else
                   add 12 to ZERO giving APPL-RESULT
               end-if
           end-if.
           if  APPL-AOK
               CONTINUE
           else
               move 'WRITE Failure with CASEPUT1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CASEPUT1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CASEPUT1-OPEN.
           add 8 to ZERO giving APPL-RESULT.
           open OUTPUT CASEPUT1-FILE
           if  CASEPUT1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'O' to CASEPUT1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'OPEN Failure with CASEPUT1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CASEPUT1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.
      *---------------------------------------------------------------*
       CASEPUT1-CLOSE.
           add 8 to ZERO giving APPL-RESULT.
           close CASEPUT1-FILE
           if  CASEPUT1-STATUS = '00'
               subtract APPL-RESULT from APPL-RESULT
               move 'C' to CASEPUT1-OPEN-FLAG
           else
               add 12 to ZERO giving APPL-RESULT
           end-if
           if  APPL-AOK
               CONTINUE
           else
               move 'CLOSE Failure with CASEPUT1' to MESSAGE-TEXT
               perform Z-DISPLAY-MESSAGE-TEXT
               move CASEPUT1-STATUS to IO-STATUS
               perform Z-DISPLAY-IO-STATUS
               perform Z-ABEND-PROGRAM
           end-if
           exit.

      *****************************************************************
      * The following Z-ROUTINES provide administrative functions     *
      * for this program.                                             *
      *****************************************************************
      * ABEND the program, post a message to the console and issue    *
      * a STOP RUN.                                                   *
      *****************************************************************
       Z-ABEND-PROGRAM.
           if  MESSAGE-TEXT not = SPACES
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           move 'PROGRAM-IS-ABENDING...'  to MESSAGE-TEXT
           perform Z-DISPLAY-MESSAGE-TEXT
           add 12 to ZERO giving RETURN-CODE
           STOP RUN.
      *    exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MESSAGE-TEXT.
           if MESSAGE-TEXT-2 = SPACES
               display MESSAGE-BUFFER(1:79)
           else
               display MESSAGE-BUFFER
           end-if
           move all SPACES to MESSAGE-TEXT
           exit.

      *****************************************************************
      * Display the file status bytes. This routine will display as   *
      * four digits. If the full two byte file status is numeric it   *
      * will display as 00nn. If the 1st byte is a numeric nine (9)   *
      * the second byte will be treated as a binary number and will   *
      * display as 9nnn.                                              *
      *****************************************************************
       Z-DISPLAY-IO-STATUS.
           if  IO-STATUS not NUMERIC
           or  IO-STAT1 = '9'
               move IO-STAT1 to IO-STATUS-04(1:1)
               subtract TWO-BYTES-BINARY from TWO-BYTES-BINARY
               move IO-STAT2 to TWO-BYTES-RIGHT
               add TWO-BYTES-BINARY to ZERO giving IO-STATUS-0403
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           else
               move '0000' to IO-STATUS-04
               move IO-STATUS to IO-STATUS-04(3:2)
               move 'File Status is: nnnn' to MESSAGE-TEXT
               move IO-STATUS-04 to MESSAGE-TEXT(17:4)
               perform Z-DISPLAY-MESSAGE-TEXT
           end-if
           exit.

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE
           display SIM-COPYRIGHT
           exit.
      *****************************************************************
      *           This program was generated by SimoZAPS              *
      *             A product of SimoTime Technologies                *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *  Generation Date: 2008-06-14  Generation Time: 18:21:27:28    *
      *****************************************************************
